
                                                 (*:  --Ŀ
                  [http://www.royale.linux-fan.com]ͻ 
                  ĿĿĿĿĿ  Ŀ  |
                .                Ŀ          
                :                   Ĵ  :
                    ٳ   Ŀ ٳ    Ŀ      .
                |           
                 [1999][royale@ifrance.com]ͼ
                --  :*)

(* ATTAQUES.INC *)

procedure attaques(debut:Tposition);
(* Cherche toutes les attaques possible depuis la position dbut *)

  procedure ajouter_attaque(i,j:byte);
  (* Fonction interne : ajoute l'attaque (i,j) au tableau des attaques *)
  begin
    inc(attaque.nombre);
    with attaque.coup[attaque.nombre].position do begin
      x:=i;
      y:=j;
    end;
  end;

var i,j:byte;
    ok:boolean;
begin
  attaque.nombre:=1;    (* On est sr qu'il y a au moins une attaque : *)
  attaque.coup[1].position:=debut; (* Rester sur place ! *)
(*** Tester la ligne vers la droite ***)
  i:=debut.x+1;
  ok:=true;
(* Tant que tout est OK, on continu *)
  while ok do begin
    if not (i<=7) then ok:=false (* Si on sort du tableau, c'est fini ! *)
    else if not (grille[i,debut.y]=vide) then ok:=false (* Ou si la case n'est
                                                           pas vide ! *)
    else ajouter_attaque(i,debut.y); (* Sinon l'attaque est valide *)
    inc(i);                          (* Attaque suivante... *)
  end;
(*** Tester la ligne vers la gauche ***)
  i:=debut.x-1;
  ok:=true;
  while ok do begin
    if not (i>=1) then ok:=false
    else if not (grille[i,debut.y]=vide) then ok:=false
    else ajouter_attaque(i,debut.y);
    dec(i);
  end;
(*** Tester la colonne vers le bas ***)
  j:=debut.y+1;
  ok:=true;
  while ok do begin
    if not(j<=7) then ok:=false
    else if not (grille[debut.x,j]=vide) then ok:=false
    else ajouter_attaque(debut.x,j);
    inc(j);
  end;
(*** Tester la colonne vers le haut ***)
  j:=debut.y-1;
  ok:=true;
  while ok do begin
    if not (j>=1) then ok:=false
    else if not(grille[debut.x,j]=vide) then ok:=false
    else ajouter_attaque(debut.x,j);
    dec(j);
  end;
end;
