
                                                 (*:  --Ŀ
                  [http://www.royale.linux-fan.com]ͻ 
                  ĿĿĿĿĿ  Ŀ  |
                .                Ŀ          
                :                   Ĵ  :
                    ٳ   Ŀ ٳ    Ŀ      .
                |           
                 [1999][royale@ifrance.com]ͼ
                --  :*)

(* MENU.INC *)

function saisir(x,y:word; tcol,fcol:byte):string;
(* Saisir un texte aux coordonnes X,Y *)
var c:char;
    s:string;
    i,j:word;
begin
  while keypressed do c:=readkey; (* Vider le buffer clavier *)
  (* Saisie vide par dfaut *)
  s:='';
  repeat
    waitretrace;
    (* Effacer l'ancien texte et son ombre *)
    copyblock(10*8+1,14+1,fond_pg,x,y,scrn_pg,x,y,true);
    (* Afficher le nouveau texte et son ombre *)
    outtextxy(scrn_pg,x,y,s,tcol,fcol);
    c:=readkey;
    case c of
      #0:c:=readkey; (* Si c'est un caractre tendu vider le buffer clavier *)
      #8:begin (* Si c'est la touche 'BACKSPACE', supprimer le dernier caractre *)
           if s[0]>#0 then dec(s[0]); (* Rduire la longueur de la chaine *)
         end;
      #13:;    (* 'ENTREE' : ne rien faire pour l'instant *)
      else if length(s)<10 then s:=s+c; (* Sinon ajouter la lettre *)
    end;
  until c=#13; (* Jusqu' ce qu'on presse la touche 'ENTREE' *)
  saisir:=s;   (* Sortie *)
end;

procedure init_menu;
(* Initialise le menu *)
begin
  fillchar(pal,768,0);
  setpal;                       (* Palette noire *)
  loadpcx('menu.pcx',fond_pg);  (* Image de fond du menu *)
  souris_off;
  copypage(fond_pg,scrn_pg);    (* Copier  l'cran *)
  souris_on;
  fade_in;                      (* Fondu d'entre *)
end;


procedure menu;
(****************************************************************************)
(* Propose  l'utilisateur un menu l'invitant  rgler les principales      *)
(* options du jeu,  visualiser les informations,  joueur ou  quitter !   *)
(* Toutes les choix retournent au menu aprs leur execution sauf le choix   *)
(* quitter.                                                                 *)
(****************************************************************************)
const NB_Choix=10;
      (* Tableau des Choix possibles *)
      CHOIX:array [1..NB_Choix] of record
                              x,y:word;        (* Position  l'cran *)
                              message:string;
                            end=
      ( (x: 20;y:  0;message:'Joueur 1 : ') ,
        (x: 20;y: 20;message:'Nom : ') ,
        (x: 20;y: 40;message:'Joueur 2 : ') ,
        (x: 20;y: 60;message:'Nom : ') ,
        (x: 20;y: 80;message:'Attaque IA : ') ,
        (x: 20;y:100;message:'Dfense IA : ') ,
        (x: 20;y:120;message:'Aide : ') ,
        (x: 20;y:140;message:'Infos ?') ,
        (x: 20;y:160;message:'JOUER') ,
        (x: 20;y:180;message:'QUITTER') );

var cmpt:byte;
    last_choix:byte;

procedure mise_a_jour;
(* Met  jour l'affichage du menu *)
var cmpt:byte;
    s:string;
begin
   copypage(fond_pg,make_pg); (* Copier le fond dans la page de construction *)
(*** Afficher tous les choix du menu *)
   for cmpt:=1 to nb_choix do with CHOIX[cmpt] do
     (* Afficher le message du choix avec la couleur 254 ou 255 si la souris
        pointe dessus *)
     outtextxy(make_pg,x,y,message,254+ord(last_choix=cmpt),0);
(* Ajouter le genre du premier joueur et son nom *)
   with choix[1] do
     (* Afficher le genre  la fin du message 'Joueur 1 : ' *)
     outtextxy(make_pg,x+length(message)*8,y,genre2string(joueur1.genre),254+ord(last_choix=1),0);
   with choix[2] do
     outtextxy(make_pg,x+length(message)*8,y,joueur1.nom,254+ord(last_choix=2),0);
(* Ajouter le genre du second joueur et son nom *)
   with choix[3] do
     outtextxy(make_pg,x+length(message)*8,y,genre2string(joueur2.genre),254+ord(last_choix=3),0);
   with choix[4] do
     outtextxy(make_pg,x+length(message)*8,y,joueur2.nom,254+ord(last_choix=4),0);
(* Afficher les niveaux d'attaque et de dfense *)
   if Niveau_IA_Attaque=facile then s:='Facile' else s:='Dur';
   with choix[5] do
     outtextxy(make_pg,x+length(message)*8,y,s,254+ord(last_choix=5),0);
   if Niveau_IA_Defense=facile then s:='Facile' else s:='Dur';
   with choix[6] do
     outtextxy(make_pg,x+length(message)*8,y,s,254+ord(last_choix=6),0);
(* Afficher l'option d'AIDE *)
   if Aide=false then s:='Non' else s:='Oui';
   with choix[7] do
     outtextxy(make_pg,x+length(message)*8,y,s,254+ord(last_choix=7),0);
(*** Tout afficher  l'cran ***)
   waitretrace;               (* Attendre le balayage cathodique *)
   souris_off;                (* Masquer la souris  *)
   copypage(make_pg,scrn_pg); (* Actualiser l'cran *)
   souris_on;                 (* Afficher la souris *)
end;

var cur_choix:byte;
    quitter:boolean;

begin
  init_menu;
  quitter:=false;
  last_choix:=255;            (* Choix non valide : pas de choix par dfaut *)
  repeat
    cur_choix:=0;             (* Choix non valide *)
    for cmpt:=1 to nb_choix do with CHOIX[cmpt] do
      (* Si la souris pointe sur un des messages *)
      if  (x_souris in [x..x+length(message)*8])
      and (y_souris in [y..y+14])
      (* Alors changer le choix courant *)
      then cur_choix:=cmpt;
    (* Si le choix courant a chang, actualiser l'affichage
       Remarque : lors de la premire boucle, 255<>0 donc le menu apparait
       grace  la premire mise  jour *)
    if last_choix<>cur_choix then begin
      last_choix:=cur_choix;
      mise_a_jour;
    end;
    (* Si l'utilisateur clique *)
    if souris_bout=1 then begin
      (* En fonction du dernier choix... *)
      case last_choix of
        (* Changer le genre du joueur 1 *)
        1:joueur1.genre:=Tgenre( (ord(joueur1.genre)+1) mod 2 );
        (* Saisir le nom du joueur 1 *)
        2:begin
            souris_off;
            with CHOIX[2] do joueur1.nom:=saisir(x+length(message)*8,y,255,0);
            souris_on;
          end;
        (* Changer le genre du joueur 2 *)
        3:joueur2.genre:=Tgenre( (ord(joueur2.genre)+1) mod 2 );
        (* Saisir le nom du joueur 2 *)
        4:begin
            souris_off;
            with CHOIX[4] do joueur2.nom:=saisir(x+length(message)*8,y,255,0);
            souris_on;
          end;
        (* Changer le niveau d'attaque *)
        5:if Niveau_IA_Attaque=facile then Niveau_IA_Attaque:=dur else Niveau_IA_Attaque:=facile;
        (* Changer le niveau de dfense *)
        6:if Niveau_IA_Defense=facile then Niveau_IA_Defense:=dur else Niveau_IA_Defense:=facile;
        (* Basculer l'aide *)
        7:Aide:=not(Aide);
        (* Afficher les informations *)
        8:begin
            fade_out;
            info;
            init_menu;
          end;
        (* Jouer *)
        9:begin
            fade_out;
            jouer;
            init_menu;
          end;
        (* Quitter *)
        10:quitter:=true;
      end;
      (* Actualiser l'affichage pour les nouveaux noms des joueurs... *)
      mise_a_jour;
      repeat until souris_bout<>1; (* Attendre que l'utilisateur lache *)
    end;
  until quitter; (* Jusqu' ce que l'option quitter soit choisie *)
  fade_out;      (* Fondu de sortie *)
  souris_off;
  clearpage(scrn_pg); (* Effacer l'cran *)
  souris_on;
end;

